package ninja.thefirearchmage.games.fourtykcalculator;

import lombok.Getter;

import java.util.*;

public class Weapon {
    @Getter
    private String name;
    @Getter
    private int strength;
    @Getter
    private int ap;
    @Getter
    private int attacks;
    @Getter
    private WeaponDamage damage;
    @Getter
    private WeaponRangeType rangeType;
    @Getter
    private int hitValue;
    private boolean hasLethalHits;
    @Getter
    private Optional<Integer> sustainedHits;
    private boolean hasDevastatingWounds;
    private boolean hasHazardous;
    private List<AntiUnitEffect> antiUnitEffects;
    private boolean hasHeavy;
    private boolean hasBlast;
    private boolean hasLance;
    private boolean ignoresCover;
    private boolean hasIndirectFire;
    @Getter
    private Optional<Integer> melta;
    @Getter
    private Optional<Integer> rapidFire;
    private boolean isPsychic;

    public Weapon(String name, int strength, int ap, int attacks, int hitValue, WeaponDamage damage,
                  WeaponRangeType weaponRangeType) {
        this.name = name;
        this.strength = strength;
        this.ap = ap;
        this.attacks = attacks;
        this.hitValue = hitValue;
        this.damage = damage;
        this.rangeType = weaponRangeType;

        this.antiUnitEffects = new ArrayList<>();
        this.melta = Optional.empty();
        this.rapidFire = Optional.empty();
        this.sustainedHits = Optional.empty();

        this.hasDevastatingWounds = false;
        this.hasHazardous = false;
        this.hasHeavy = false;
        this.hasBlast = false;
        this.hasLance = false;
        this.ignoresCover = false;
        this.hasIndirectFire = false;
        this.hasLethalHits = false;
    }

    public WeaponAttackResolution generateAttackResolution(DefensiveProfile target, UnitAttackModifiers unitModifiers) {
        var weaponAttackResolution = new WeaponAttackResolution();



        return weaponAttackResolution;
    }

    /**
     * Returns whether this weapon is anti for any of the given types
     */
    public boolean isAntiFor(Set<UnitTypeKeyword> unitTypes) {
        var antiUnitTypes = antiStats.keySet();
        return unitTypes.stream().anyMatch(antiUnitTypes::contains);
    }
    public Optional<Integer> getBestAntiFor(DefensiveProfile target) {
        var bestAnti = Optional.<Integer>empty();
        if(isAntiFor(target.getUnitTypeKeywords())) {
            var antiUnitTypes = antiStats.keySet();
            var minAnti = target.getUnitTypeKeywords().stream()
                    .filter(antiUnitTypes::contains)
                    .mapToInt(type -> antiStats.get(type))
                    .min().getAsInt();
            bestAnti = Optional.of(minAnti);
        }

        return bestAnti;
    }
}
