package ninja.thefirearchmage.games.fourtykcalculator;

import lombok.Getter;

import java.util.Optional;

@Getter
public class WeaponDamage {
    private final Optional<Integer> diceType;
    private final Optional<Integer> numberOfDices;
    private final int flatDamage;

    public WeaponDamage(int flatDamage) {
        this(Optional.empty(), Optional.empty(), flatDamage);
    }
    public WeaponDamage(int diceType, int numberOfDices) {
        this(Optional.of(diceType), Optional.of(numberOfDices), 0);
    }
    public WeaponDamage(int diceType, int numberOfDices, int extraDamage) {
        this(Optional.of(diceType), Optional.of(numberOfDices), extraDamage);
    }
    public WeaponDamage(Optional<Integer> diceType, Optional<Integer> numberOfDices, int flatDamage) {
        this.diceType = diceType;
        this.numberOfDices = numberOfDices;
        this.flatDamage = flatDamage;
    }
}
