package ninja.thefirearchmage.games.fourtykcalculator.utils.functions;

/**
 * A functional interface that allows to return a value and declare that it may throw exceptions, to be used
 * for Try.
 * @param <T> the return value
 * @param <X> the type of exception
 */
@FunctionalInterface
public interface CheckedCallable<T, X extends Throwable> {
    T call() throws X;
}
