package ninja.thefirearchmage.games.fourtykcalculator;

import lombok.Getter;

@Getter
public class InvulnerableSave {
    private final int rollValue;
    private final InvulnerableType type;

    public InvulnerableSave(int rollValue) {
        this(rollValue, InvulnerableType.ALL);
    }

    public InvulnerableSave(int rollValue, InvulnerableType type) {
        this.rollValue = rollValue;
        this.type = type;
    }

    /**
     * Checks whether this invulnerable save applies to the given weapon attack
     */
    public boolean appliesTo(Weapon weapon) {
        return switch(weapon.getRangeType()) {
            case MELEE -> type == InvulnerableType.MELEE || type == InvulnerableType.ALL;
            case RANGED -> type == InvulnerableType.RANGED || type == InvulnerableType.ALL;
        };
    }
}
